'use strict';

var ricosTypes = require('ricos-types');
var consts = require('./consts.js');
var getAddButtons = require('./getAddButtons.js');
var getToolbarButtons = require('./getToolbarButtons.js');
var settings_settings = require('./settings/settings.js');
var tiptap_tiptap = require('./tiptap/tiptap.js');
var types = require('./types.js');
require('ricos-schema');
require('wix-rich-content-editor-common');
require('wix-rich-content-plugin-commons');
require('./toolbar/imagePluginService.js');
require('lodash');
require('./icons/InsertPluginIcon.js');
require('react');
require('wix-rich-content-toolbars-ui');
require('./image-editor-modal/image-editor-modal.js');
require('ricos-context');
require('./imageStudio/image-editor-logic.js');
require('./imageStudio/image-studio-opener-loader.js');
require('./toolbar/ImageEditorButton.js');
require('@wix/design-system');
require('wix-rich-content-ui-components');
require('./dataHooks.js');
require('./settings/use-spoiler-plugin.js');
require('ricos-content');
require('ricos-schema/dist/statics/image.defaults.json');
require('./tiptap/component.js');
require('./viewer/get-image-click-action-config.js');
require('./viewer/image.js');
require('classnames');
require('./image-viewer.rtlignore-f6a3b7a2.js');
require('./style-inject.es-e29c91b9.js');
require('./icons/expand.js');
require('./viewer/image-container.js');
require('./viewer/use-custom-width-style.js');
require('./viewer/use-fallback-width-style.js');
require('./viewer/use-image-dimensions.js');
require('./viewer/use-image-social-attributes.js');
require('./tiptap/editor-image-caption.js');
require('./InPluginInput.js');

var __defProp = Object.defineProperty;
var __getOwnPropSymbols = Object.getOwnPropertySymbols;
var __hasOwnProp = Object.prototype.hasOwnProperty;
var __propIsEnum = Object.prototype.propertyIsEnumerable;
var __defNormalProp = (obj, key, value) => key in obj ? __defProp(obj, key, { enumerable: true, configurable: true, writable: true, value }) : obj[key] = value;
var __spreadValues = (a, b) => {
  for (var prop in b || (b = {}))
    if (__hasOwnProp.call(b, prop))
      __defNormalProp(a, prop, b[prop]);
  if (__getOwnPropSymbols)
    for (var prop of __getOwnPropSymbols(b)) {
      if (__propIsEnum.call(b, prop))
        __defNormalProp(a, prop, b[prop]);
    }
  return a;
};
const pluginImage = (config) => {
  const pluginConfig = __spreadValues(__spreadValues({}, consts.DEFAULTS.config), config);
  return {
    config: pluginConfig,
    type: types.IMAGE_TYPE,
    tiptapExtensions: tiptap_tiptap.tiptapExtensions,
    toolbar: {
      names: [ricosTypes.RicosPluginToolbarNames.IMAGE],
      getButtons: (config2, services) => getToolbarButtons.getToolbarButtons(config2, services)
    },
    getAddButtons: (config2, services) => getAddButtons.getAddButtons(config2, services),
    __exports: {
      SettingsModal: settings_settings.Settings
    }
  };
};

exports.pluginImage = pluginImage;
//# sourceMappingURL=editor.js.map
