'use strict';

var React = require('react');
var ricosContext = require('ricos-context');
var wixRichContentPluginCommons = require('wix-rich-content-plugin-commons');
var consts = require('../consts.js');
var imageStudio_imageEditorLogic = require('../imageStudio/image-editor-logic.js');
var types = require('../types.js');
require('ricos-schema');
require('../imageStudio/image-studio-opener-loader.js');

function _interopDefaultCompat (e) { return e && typeof e === 'object' && 'default' in e ? e : { default: e }; }

var React__default = /*#__PURE__*/_interopDefaultCompat(React);

const ImageEditorModal = ({
  nodeId,
  imagePluginService,
  handleFileUpload,
  imageEditorWixSettings,
  onImageEditorOpen,
  src
}) => {
  const uploader = new wixRichContentPluginCommons.Uploader(handleFileUpload);
  const modalService = React.useContext(ricosContext.ModalContext) || {};
  const uploadContext = React.useContext(ricosContext.UploadContext) || {};
  const id = "imageEditor";
  React__default.default.useEffect(() => {
    const onClose = () => {
      modalService.closeModal(consts.imageModals.imageEditor);
    };
    const onSave = (file) => {
      var _a;
      (_a = uploadContext.uploadService) == null ? void 0 : _a.uploadFile(
        file,
        nodeId,
        uploader,
        types.IMAGE_TYPE,
        imagePluginService
      );
      onClose();
    };
    onImageEditorOpen && onImageEditorOpen();
    imageStudio_imageEditorLogic.setupImageEditor(imageEditorWixSettings, id, src, onSave, onClose);
  }, []);
  return /* @__PURE__ */ React__default.default.createElement("div", { id, nofocus: "true" });
};

module.exports = ImageEditorModal;
//# sourceMappingURL=image-editor-modal.js.map
