'use strict';

var React = require('react');
var ricosContent = require('ricos-content');
var ricosContext = require('ricos-context');
var types = require('../types.js');

const useSpoilerPlugin = () => {
  const plugins = React.useContext(ricosContext.PluginsContext);
  return React.useMemo(() => {
    const spoilerPlugin = plugins.asArray().find((plugin) => plugin.getType() === ricosContent.SPOILER_TYPE);
    const isSpoilerPluginAvailable = spoilerPlugin && (!spoilerPlugin.getConfig().supportedPlugins || spoilerPlugin.getConfig().supportedPlugins.includes(types.IMAGE_TYPE));
    return isSpoilerPluginAvailable;
  }, [plugins]);
};

exports.useSpoilerPlugin = useSpoilerPlugin;
//# sourceMappingURL=use-spoiler-plugin.js.map
