'use strict';

var React = require('react');
var ricosContext = require('ricos-context');
var ricosSchema = require('ricos-schema');
var wixRichContentUiComponents = require('wix-rich-content-ui-components');
var viewer_getImageClickActionConfig = require('../viewer/get-image-click-action-config.js');
var viewer_image = require('../viewer/image.js');
var styleInject_es = require('../style-inject.es-e29c91b9.js');
var tiptap_editorImageCaption = require('./editor-image-caption.js');
require('classnames');
require('../image-viewer.rtlignore-f6a3b7a2.js');
require('../consts.js');
require('../icons/expand.js');
require('../viewer/image-container.js');
require('../dataHooks.js');
require('../viewer/use-custom-width-style.js');
require('../viewer/use-fallback-width-style.js');
require('../viewer/use-image-dimensions.js');
require('../viewer/use-image-social-attributes.js');
require('lodash');
require('../InPluginInput.js');

function _interopDefaultCompat (e) { return e && typeof e === 'object' && 'default' in e ? e : { default: e }; }

var React__default = /*#__PURE__*/_interopDefaultCompat(React);

var css_248z = ".NxGff{align-items:center;display:flex;gap:20px}[dir] .NxGff{padding:0 20px}";
var styles = {"captionWrapper":"NxGff"};
styleInject_es.styleInject(css_248z);

const EditorImage = ({ updateAttributes, node }) => {
  var _a, _b, _c, _d, _e, _f;
  const { t, isMobile } = React.useContext(ricosContext.RicosContext);
  const { loading, loadingPercentage, error, tempData } = node.attrs;
  const pluginExports = ricosContext.usePluginExportsContext();
  const onCaptionChange = (caption2) => {
    updateAttributes({ caption: caption2 });
  };
  const { src } = node.attrs.image || {};
  const shouldRender = !!tempData || (src == null ? void 0 : src.url) || (src == null ? void 0 : src.id);
  const ricosNode = {
    imageData: node.attrs,
    id: node.attrs.id,
    type: ricosSchema.Node_Type.IMAGE,
    nodes: []
  };
  const imageClickActionConfig = viewer_getImageClickActionConfig.getImageClickActionConfig({
    imageData: ricosNode.imageData
  });
  const AiCaptionTrigger = ((_b = (_a = pluginExports.aiIntegrations) == null ? void 0 : _a.image) == null ? void 0 : _b.captionTrigger) ? (_d = (_c = pluginExports == null ? void 0 : pluginExports.aiIntegrations) == null ? void 0 : _c.image) == null ? void 0 : _d.captionTrigger : null;
  const caption = /* @__PURE__ */ React__default.default.createElement(
    tiptap_editorImageCaption.EditorImageCaption,
    {
      onCaptionChange,
      imageType: imageClickActionConfig.type,
      caption: (_f = (_e = ricosNode.imageData) == null ? void 0 : _e.caption) != null ? _f : ""
    }
  );
  return shouldRender ? /* @__PURE__ */ React__default.default.createElement(React__default.default.Fragment, null, /* @__PURE__ */ React__default.default.createElement(
    viewer_image.Image,
    {
      isMobile,
      node: ricosNode,
      dataUrl: tempData,
      imageClickActionConfig: { type: "regular" },
      shouldLazyLoadImages: false,
      captionComponent: AiCaptionTrigger ? (
        // This is temporary solution until we make caption rich
        /* @__PURE__ */ React__default.default.createElement("div", { className: styles.captionWrapper }, /* @__PURE__ */ React__default.default.createElement(
          AiCaptionTrigger,
          {
            node: ricosNode,
            onCaptionChange
          }
        ), caption)
      ) : caption
    }
  ), loading && /* @__PURE__ */ React__default.default.createElement(wixRichContentUiComponents.Loader, { type: "medium", percent: loadingPercentage }), error && /* @__PURE__ */ React__default.default.createElement(wixRichContentUiComponents.MediaItemErrorMsg, { error, t })) : null;
};

exports.EditorImage = EditorImage;
//# sourceMappingURL=component.js.map
