'use strict';

var ricosContent = require('ricos-content');
var imageDataDefaults = require('ricos-schema/dist/statics/image.defaults.json');
var wixRichContentPluginCommons = require('wix-rich-content-plugin-commons');
var toolbar_imagePluginService = require('../toolbar/imagePluginService.js');
var tiptap_component = require('./component.js');
require('lodash');
require('react');
require('ricos-context');
require('ricos-schema');
require('wix-rich-content-ui-components');
require('../viewer/get-image-click-action-config.js');
require('../viewer/image.js');
require('classnames');
require('../image-viewer.rtlignore-f6a3b7a2.js');
require('../style-inject.es-e29c91b9.js');
require('../consts.js');
require('../icons/expand.js');
require('../viewer/image-container.js');
require('../dataHooks.js');
require('../viewer/use-custom-width-style.js');
require('../viewer/use-fallback-width-style.js');
require('../viewer/use-image-dimensions.js');
require('../viewer/use-image-social-attributes.js');
require('./editor-image-caption.js');
require('../InPluginInput.js');

function _interopDefaultCompat (e) { return e && typeof e === 'object' && 'default' in e ? e : { default: e }; }

var imageDataDefaults__default = /*#__PURE__*/_interopDefaultCompat(imageDataDefaults);

var __defProp = Object.defineProperty;
var __defProps = Object.defineProperties;
var __getOwnPropDescs = Object.getOwnPropertyDescriptors;
var __getOwnPropSymbols = Object.getOwnPropertySymbols;
var __hasOwnProp = Object.prototype.hasOwnProperty;
var __propIsEnum = Object.prototype.propertyIsEnumerable;
var __defNormalProp = (obj, key, value) => key in obj ? __defProp(obj, key, { enumerable: true, configurable: true, writable: true, value }) : obj[key] = value;
var __spreadValues = (a, b) => {
  for (var prop in b || (b = {}))
    if (__hasOwnProp.call(b, prop))
      __defNormalProp(a, prop, b[prop]);
  if (__getOwnPropSymbols)
    for (var prop of __getOwnPropSymbols(b)) {
      if (__propIsEnum.call(b, prop))
        __defNormalProp(a, prop, b[prop]);
    }
  return a;
};
var __spreadProps = (a, b) => __defProps(a, __getOwnPropDescs(b));
const name = ricosContent.TIPTAP_IMAGE_TYPE;
const tiptapExtensions = [
  wixRichContentPluginCommons.createRicosNodeExtension({
    type: "react-node",
    name,
    groups: ["spoilerable", "resizable", "draggable", "not-overtypable"],
    reconfigure: (config, _extensions, _props, settings, services) => __spreadProps(__spreadValues({}, config), {
      addOptions: () => __spreadValues({
        services,
        imagePluginService: new toolbar_imagePluginService.ImagePluginService()
      }, settings)
    }),
    Component: tiptap_component.EditorImage,
    createExtensionConfig({ Plugin, PluginKey }) {
      return {
        name: this.name,
        atom: false,
        group: "block",
        selectable: true,
        draggable: true,
        addAttributes: () => __spreadProps(__spreadValues({}, imageDataDefaults__default.default), {
          loading: {
            default: false
          },
          loadingPercentage: {
            default: null
          },
          tempData: {
            default: null
          }
        }),
        addProseMirrorPlugins() {
          return [
            new Plugin({
              key: new PluginKey("handlePasteImage"),
              props: {
                handlePaste: (_, event) => {
                  var _a, _b;
                  let hasFiles = false;
                  if ((_a = event == null ? void 0 : event.clipboardData) == null ? void 0 : _a.types.includes("text/plain")) {
                    return false;
                  }
                  Array.from(((_b = event == null ? void 0 : event.clipboardData) == null ? void 0 : _b.files) || []).filter((file) => file.type.startsWith("image")).forEach((file) => {
                    var _a2, _b2;
                    const nodeId = ricosContent.generateId();
                    this.editor.commands.insertContent({
                      type: ricosContent.TIPTAP_IMAGE_TYPE,
                      attrs: __spreadValues({ id: nodeId }, imageDataDefaults__default.default)
                    });
                    (_b2 = (_a2 = this.options.services) == null ? void 0 : _a2.uploadService) == null ? void 0 : _b2.uploadFile(
                      file,
                      nodeId,
                      new wixRichContentPluginCommons.Uploader(this.options.handleFileUpload),
                      ricosContent.TIPTAP_IMAGE_TYPE,
                      this.options.imagePluginService
                    );
                    hasFiles = true;
                  });
                  if (hasFiles) {
                    event.preventDefault();
                    return true;
                  }
                  return false;
                }
              }
            })
          ];
        },
        addCommands() {
          return {
            setImageUrl: (url) => ({ commands }) => {
              return commands.updateAttributes(name, { image: { src: { custom: url } } });
            },
            setImageLoading: (loading) => ({ commands }) => {
              return commands.updateAttributes(name, { loading });
            }
          };
        }
      };
    }
  })
];

exports.tiptapExtensions = tiptapExtensions;
//# sourceMappingURL=tiptap.js.map
