'use strict';

var React = require('react');
var ricosContext = require('ricos-context');
var wixRichContentToolbarsUi = require('wix-rich-content-toolbars-ui');

function _interopDefaultCompat (e) { return e && typeof e === 'object' && 'default' in e ? e : { default: e }; }

var React__default = /*#__PURE__*/_interopDefaultCompat(React);

const ImageEditorButton = ({ toolbarItem, dataHook }) => {
  var _a, _b;
  const { t } = React.useContext(ricosContext.RicosContext) || {};
  const onClick = toolbarItem.commands.click;
  const node = toolbarItem.attributes.selectedNode;
  const src = (_b = (_a = node == null ? void 0 : node.attrs.image) == null ? void 0 : _a.src) == null ? void 0 : _b.id;
  return /* @__PURE__ */ React__default.default.createElement(
    wixRichContentToolbarsUi.ToggleButton,
    {
      Icon: wixRichContentToolbarsUi.EditIcon,
      onClick: () => onClick({ src }),
      dataHook,
      tooltip: t("ImageEditorButton_Tooltip"),
      disabled: !src
    }
  );
};

module.exports = ImageEditorButton;
//# sourceMappingURL=ImageEditorButton.js.map
