'use strict';

var lodash = require('lodash');
var ricosSchema = require('ricos-schema');
var styleInject_es = require('../style-inject.es-e29c91b9.js');

var css_248z = ".krJxk{margin-left:0;margin-right:auto;z-index:1}.krJxk:not(.G8DsY){float:left;margin-right:40px}@supports not (contain:inline-size){@media only screen and (max-width:640px){.krJxk:not(.G8DsY){float:none;margin-right:auto}}}@container (width < 640px){.krJxk:not(.G8DsY){float:none;margin-right:auto}}.GM95P{margin-left:auto;margin-right:0;z-index:1}.GM95P:not(.G8DsY){float:right;margin-left:40px}@supports not (contain:inline-size){@media only screen and (max-width:640px){.GM95P:not(.G8DsY){float:none;margin-left:auto}}}@container (width < 640px){.GM95P:not(.G8DsY){float:none;margin-left:auto}}.SwKHm{display:block}.SwKHm:not(.lmA7b){margin-left:auto;margin-right:auto;max-width:100%}.G8DsY,.lmA7b{width:100%}.xLE4d .G8DsY,.xLE4d .lmA7b{margin:0 -8px;width:auto}.A1qtC{width:fit-content}._3uVI9{margin-left:auto;margin-right:auto;max-width:100%}.KwewA{width:min(350px,100%)!important}.xLE4d .KwewA{width:50%}.Xo6cA{margin-left:auto;margin-right:auto}.xLE4d .Xo6cA{width:150px}.FQLwy{display:flex}";
var styles = {"alignLeft":"krJxk","textWrapNowrap":"G8DsY","alignRight":"GM95P","alignCenter":"SwKHm","sizeFullWidth":"lmA7b","renderedInTable":"xLE4d","sizeOriginal":"A1qtC","sizeContent":"_3uVI9","sizeSmall":"KwewA","sizeSmallCenter":"Xo6cA","flex":"FQLwy"};
styleInject_es.styleInject(css_248z);

const alignmentClassName = (node) => {
  var _a, _b;
  const { alignment, width } = ((_a = node.imageData) == null ? void 0 : _a.containerData) || {};
  if (!alignment) {
    return "";
  }
  let align = alignment;
  if ((width == null ? void 0 : width.size) === ricosSchema.PluginContainerData_Width_Type.ORIGINAL && alignment !== ricosSchema.PluginContainerData_Alignment.CENTER) {
    const { width: width2 } = ((_b = node.imageData) == null ? void 0 : _b.image) || {};
    if (lodash.isNumber(width2) && width2 > 350) {
      align = ricosSchema.PluginContainerData_Alignment.CENTER;
    }
  }
  return styles[`align${lodash.upperFirst(align.toLowerCase())}`];
};
const sizeClassName = (node, isMobile) => {
  var _a;
  const { width } = ((_a = node.imageData) == null ? void 0 : _a.containerData) || {};
  if (!(width == null ? void 0 : width.size) || isMobile && (width == null ? void 0 : width.size) === ricosSchema.PluginContainerData_Width_Type.ORIGINAL) {
    return "";
  }
  return (width == null ? void 0 : width.size) === ricosSchema.PluginContainerData_Width_Type.FULL_WIDTH ? styles.sizeFullWidth : styles[`size${lodash.upperFirst(lodash.camelCase(width.size.toLowerCase()))}`];
};
const textWrapClassName = (node) => {
  var _a;
  const { textWrap } = ((_a = node.imageData) == null ? void 0 : _a.containerData) || {};
  if (textWrap) {
    return "";
  }
  return styles.textWrapNowrap;
};

exports.alignmentClassName = alignmentClassName;
exports.sizeClassName = sizeClassName;
exports.textWrapClassName = textWrapClassName;
//# sourceMappingURL=class-name-strategies.js.map
