'use strict';

var React = require('react');

const useImageDimensions = ({
  src,
  containerData,
  image
}) => {
  var _a, _b;
  const [dimensions, setDimensions] = React.useState({
    width: void 0,
    height: void 0
  });
  const width = (image == null ? void 0 : image.width) || Number((_a = containerData == null ? void 0 : containerData.width) == null ? void 0 : _a.custom) || dimensions.width;
  const height = (image == null ? void 0 : image.height) || Number((_b = containerData == null ? void 0 : containerData.height) == null ? void 0 : _b.custom) || dimensions.height;
  React.useLayoutEffect(() => {
    if (typeof width === "number" && typeof height === "number") {
      return;
    }
    setDimensions({ width: void 0, height: void 0 });
    if (!src) {
      return;
    }
    const newImg = new Image();
    newImg.onload = () => setDimensions({ width: newImg.width, height: newImg.height });
    newImg.src = src;
    return () => {
      newImg.onload = null;
    };
  }, [src]);
  return {
    width,
    height
  };
};

exports.useImageDimensions = useImageDimensions;
//# sourceMappingURL=use-image-dimensions.js.map
