'use strict';

var React = require('react');
var ricosContext = require('ricos-context');
var types = require('../types.js');
var viewer_classNameStrategies = require('./class-name-strategies.js');
var viewer_getExpandFunction = require('./get-expand-function.js');
var viewer_getImageClickActionConfig = require('./get-image-click-action-config.js');
var viewer_image = require('./image.js');
var viewer_viewerImageCaption = require('./viewer-image-caption.js');
require('lodash');
require('ricos-schema');
require('../style-inject.es-e29c91b9.js');
require('ricos-content');
require('classnames');
require('wix-rich-content-ui-components');
require('../image-viewer.rtlignore-f6a3b7a2.js');
require('../consts.js');
require('../icons/expand.js');
require('./image-container.js');
require('../dataHooks.js');
require('./use-custom-width-style.js');
require('./use-fallback-width-style.js');
require('./use-image-dimensions.js');
require('./use-image-social-attributes.js');

function _interopDefaultCompat (e) { return e && typeof e === 'object' && 'default' in e ? e : { default: e }; }

var React__default = /*#__PURE__*/_interopDefaultCompat(React);

var __defProp = Object.defineProperty;
var __getOwnPropSymbols = Object.getOwnPropertySymbols;
var __hasOwnProp = Object.prototype.hasOwnProperty;
var __propIsEnum = Object.prototype.propertyIsEnumerable;
var __defNormalProp = (obj, key, value) => key in obj ? __defProp(obj, key, { enumerable: true, configurable: true, writable: true, value }) : obj[key] = value;
var __spreadValues = (a, b) => {
  for (var prop in b || (b = {}))
    if (__hasOwnProp.call(b, prop))
      __defNormalProp(a, prop, b[prop]);
  if (__getOwnPropSymbols)
    for (var prop of __getOwnPropSymbols(b)) {
      if (__propIsEnum.call(b, prop))
        __defNormalProp(a, prop, b[prop]);
    }
  return a;
};
var __objRest = (source, exclude) => {
  var target = {};
  for (var prop in source)
    if (__hasOwnProp.call(source, prop) && exclude.indexOf(prop) < 0)
      target[prop] = source[prop];
  if (source != null && __getOwnPropSymbols)
    for (var prop of __getOwnPropSymbols(source)) {
      if (exclude.indexOf(prop) < 0 && __propIsEnum.call(source, prop))
        target[prop] = source[prop];
    }
  return target;
};
const ViewerImage = ({ node, nodeIndex, NodeViewContainer }) => {
  var _a, _b;
  const { config: viewerConfig, seoMode, helpers } = React.useContext(ricosContext.RicosViewerContext);
  const { isMobile, t } = React.useContext(ricosContext.RicosContext);
  const config = (_a = viewerConfig[types.IMAGE_TYPE]) != null ? _a : {};
  const expand = viewer_getExpandFunction.getExpandFunction({
    helpers,
    config,
    nodeId: node.id,
    imageData: node.imageData
  });
  const imageClickActionConfig = viewer_getImageClickActionConfig.getImageClickActionConfig({
    imageData: node.imageData,
    config,
    expand
  });
  return /* @__PURE__ */ React__default.default.createElement(
    NodeViewContainer,
    {
      node,
      nodeIndex,
      customClassNames: {
        alignment: viewer_classNameStrategies.alignmentClassName(node),
        size: viewer_classNameStrategies.sizeClassName(node, isMobile),
        textWrap: viewer_classNameStrategies.textWrapClassName(node)
      }
    },
    /* @__PURE__ */ React__default.default.createElement(
      viewer_image.Image,
      {
        node,
        imageClickActionConfig,
        expand,
        config,
        seoMode,
        helpers,
        isMobile,
        shouldLazyLoadImages: true,
        captionComponent: /* @__PURE__ */ React__default.default.createElement(
          viewer_viewerImageCaption.ViewerImageCaption,
          {
            imageType: imageClickActionConfig.type,
            caption: (_b = node == null ? void 0 : node.imageData) == null ? void 0 : _b.caption,
            defaultCaption: t("ImageViewer_Caption")
          }
        )
      }
    )
  );
};
const ImageRenderer = (_a) => {
  var _b = _a, { node } = _b, props = __objRest(_b, ["node"]);
  return /* @__PURE__ */ React__default.default.createElement(ViewerImage, __spreadValues({ key: node.id, node }, props));
};

module.exports = ImageRenderer;
//# sourceMappingURL=viewer-image.js.map
