import React, { useContext } from 'react';
import { ModalContext, UploadContext } from 'ricos-context';
import { Uploader } from 'wix-rich-content-plugin-commons';
import { imageModals } from '../consts.js';
import { setupImageEditor } from '../imageStudio/image-editor-logic.js';
import { IMAGE_TYPE } from '../types.js';
import 'ricos-schema';
import '../imageStudio/image-studio-opener-loader.js';

const ImageEditorModal = ({
  nodeId,
  imagePluginService,
  handleFileUpload,
  imageEditorWixSettings,
  onImageEditorOpen,
  src
}) => {
  const uploader = new Uploader(handleFileUpload);
  const modalService = useContext(ModalContext) || {};
  const uploadContext = useContext(UploadContext) || {};
  const id = "imageEditor";
  React.useEffect(() => {
    const onClose = () => {
      modalService.closeModal(imageModals.imageEditor);
    };
    const onSave = (file) => {
      var _a;
      (_a = uploadContext.uploadService) == null ? void 0 : _a.uploadFile(
        file,
        nodeId,
        uploader,
        IMAGE_TYPE,
        imagePluginService
      );
      onClose();
    };
    onImageEditorOpen && onImageEditorOpen();
    setupImageEditor(imageEditorWixSettings, id, src, onSave, onClose);
  }, []);
  return /* @__PURE__ */ React.createElement("div", { id, nofocus: "true" });
};

export { ImageEditorModal as default };
//# sourceMappingURL=image-editor-modal.js.map
