import classNames from 'classnames';
import React from 'react';
import { s as styles } from '../image-viewer.rtlignore-ae1ccfe6.js';
import '../style-inject.es-e7b07dd7.js';

const ViewerImageCaption = ({
  imageType,
  caption,
  defaultCaption
}) => {
  const isLinkImage = imageType === "link" || imageType === "anchor";
  const classes = classNames(styles.imageCaption, { [styles.link]: isLinkImage });
  if (!caption || caption === defaultCaption) {
    return null;
  }
  return /* @__PURE__ */ React.createElement("figcaption", { dir: "auto", className: classes }, caption);
};

export { ViewerImageCaption };
//# sourceMappingURL=viewer-image-caption.js.map
