import { ImageUniDriver, InputUniDriver, ToggleSwitchUniDriver } from '@wix/design-system/dist/testkit/unidriver';
import type { GetOptions, Testkit, UniDriver } from 'ricos-types/testkit';
import { RicosPluginToolbarNames } from 'wix-rich-content-common';
import type { FooterActionsUnidrver } from 'wix-rich-content-ui-components/testkit';
import { imageAddToolbars } from './getAddButtons';
export type ImageTestkit = Testkit<{
    content: {
        atIndex: (index: number) => {
            exists: (options?: GetOptions) => Promise<boolean>;
            click: () => Promise<void>;
            getText: () => Promise<string>;
            getAlt: () => Promise<string>;
            hasSpoiler: () => Promise<boolean>;
            getStyle: () => Promise<string | null>;
        };
    };
    settings: {
        image: ReturnType<typeof ImageUniDriver>;
        disableExpandToggle: ReturnType<typeof ToggleSwitchUniDriver>;
        disableDownloadToggle: ReturnType<typeof ToggleSwitchUniDriver>;
        spoilerToggle: ReturnType<typeof ToggleSwitchUniDriver>;
        captionInput: ReturnType<typeof InputUniDriver> & {
            waitForElement: () => Promise<void>;
        };
        altTextInput: ReturnType<typeof InputUniDriver>;
    } & FooterActionsUnidrver;
    toolbars: {
        createAddButtonToolbars: (getAddButtonBase: () => UniDriver<Element>) => {
            click: () => Promise<void>;
            toolbarsToAddIn: typeof imageAddToolbars;
        };
        createPluginToolbar: (getPluginToolbarBase: (pluginType: typeof RicosPluginToolbarNames.IMAGE) => UniDriver<Element>) => {
            openSettingsModal: () => Promise<void>;
            clickDelete: () => Promise<void>;
            openLinkPanel: () => Promise<void>;
            clickSizeDropdown: () => Promise<void>;
            imageSize: {
                clickSmall: () => Promise<void>;
            };
            exists: () => Promise<boolean>;
        };
    };
}>;
export declare const createImageTestkit: ImageTestkit;
//# sourceMappingURL=testkit.d.ts.map