import type { IMediaPluginService, IMessage, UploadedData } from 'ricos-types';
import type { ComponentData } from 'wix-rich-content-common';
export declare class ImagePluginService implements IMediaPluginService {
    createLoadingData(_: File, url: unknown, componentData: ComponentData): {
        componentData: {
            [x: string]: any;
            config?: {
                alignment?: string | undefined;
                size?: string | undefined;
                url?: string | undefined;
                textWrap?: string | undefined;
                width?: string | number | undefined;
                height?: number | undefined;
                spoiler?: {
                    enabled?: boolean | undefined;
                    description?: string | undefined;
                    buttonContent?: string | undefined;
                } | undefined;
                link?: {
                    url?: string | undefined;
                    rel?: string | undefined;
                    target?: string | undefined;
                } | undefined;
                anchor?: string | undefined;
                disableExpand?: boolean | undefined;
                direction?: string | undefined;
            } | undefined;
            src?: any;
            srcType?: string | undefined;
        };
        componentState: {
            tempData: unknown;
            loading: boolean;
        };
    };
    createPluginData(uploadedData: UploadedData, componentData: ComponentData): {
        image: {
            src: {
                id: string;
            };
            width: number;
            height: number;
        };
    };
    createErrorData(error: IMessage, componentData: ComponentData): {
        error: import("wix-rich-content-common").MediaUploadError;
    };
}
//# sourceMappingURL=imagePluginService.d.ts.map